import { IAwsInvoker, IExecuteAutomationHook, ISleepHook } from '../..';
import { ExecuteAutomationProps, ExecuteAutomationOutputs } from '../execute-automation-hook';
export interface ApiExecuteAutomationProps {
    readonly awsInvoker: IAwsInvoker;
    readonly sleepHook: ISleepHook;
}
/**
 * ExecuteAutomation implementation using AWS API
 */
export declare class ApiExecuteAutomationHook implements IExecuteAutomationHook {
    private static readonly RunningStatuses;
    readonly props: ApiExecuteAutomationProps;
    constructor(awsInvoker: IAwsInvoker, sleepHook: ISleepHook);
    execute(props: ExecuteAutomationProps): ExecuteAutomationOutputs;
    private parameterValidation;
    private startExecution;
    private getExecuteProps;
    private adaptExecuteParameters;
    private adaptTargetMaps;
    private waitForExecution;
    private getExecution;
}
