/**
 * This can be used to provide a hook for pausing implementation for PauseStep.
 */
export interface IPauseHook {
    pause(): void;
}
/**
 * This IPauseHook implementation provides a real pause and wait for user input of Enter.
 * This implementation does not work well on all exported JSII languages.
 * Users can provide their own impl using the IPauseHook interface.
 */
export declare class PauseImpl implements IPauseHook {
    pause(): void;
}
export declare class MockPause implements IPauseHook {
    timesInvoked: number;
    pause(): void;
}
