import { CopyImageStep } from '../../parent-steps/automation/copy-image-step';
import { AutomationSimulationBase } from './automation-simulation-base';
import { AwsInvocationSimulationProps } from './aws-api-simulation';
/**
 * AutomationStep implemenation for aws:copyImage
 * https://docs.aws.amazon.com/systems-manager/latest/userguide/automation-action-copyimage.html
 */
export declare class CopyImageSimulation extends AutomationSimulationBase {
    readonly action: string;
    private copyImageStep;
    private props;
    constructor(step: CopyImageStep, props: AwsInvocationSimulationProps);
    executeStep(inputs: Record<string, any>): Record<string, any>;
    private copyImage;
    private waitForImageAvailable;
}
