import { CreateImageStep } from '../../parent-steps/automation/create-image-step';
import { AutomationSimulationBase } from './automation-simulation-base';
import { AwsInvocationSimulationProps } from './aws-api-simulation';
/**
 * AutomationStep implemenation for aws:createImage
 * https://docs.aws.amazon.com/systems-manager/latest/userguide/automation-action-create.html
 */
export declare class CreateImageSimulation extends AutomationSimulationBase {
    readonly action: string;
    private createImageStep;
    private props;
    constructor(step: CreateImageStep, props: AwsInvocationSimulationProps);
    executeStep(inputs: Record<string, any>): Record<string, any>;
    private createImage;
    private waitForImageAvailable;
}
